## canu 1.3+dfsg

=== debian/changelog ===
canu (1.3+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #395843)

 -- Afif Elghraoui <afif@debian.org>  Sun, 09 Oct 2016 21:53:18 -0700

## canu 1.5+dfsg

=== src/Makefile ===
# boilermake: A reusable, but flexible, boilerplate Makefile.
#
# Copyright 2008, 2009, 2010 Dan Moulding, Alan T. DeKok
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Caution: Don't edit this Makefile! Create your own main.mk and other
#          submakefiles, which will be included by this Makefile.
#          Only edit this if you need to modify boilermake's behavior (fix
#          bugs, add features, etc).

# Note: Parameterized "functions" in this makefile that are marked with
#       "USE WITH EVAL" are only useful in conjuction with eval. This is
#       because those functions result in a block of Makefile syntax that must
#       be evaluated after expansion. Since they must be used with eval, most
#       instances of "$" within them need to be escaped with a second "$" to
#       accomodate the double expansion that occurs when eval is invoked.

# ADD_CLEAN_RULE - Parameterized "function" that adds a new rule and phony
#   target for cleaning the specified target (removing its build-generated
#   files).
#
#   USE WITH EVAL
#
define ADD_CLEAN_RULE
    clean: clean_${1}
    .PHONY: clean_${1}
    clean_${1}:
	$$(strip rm -f ${TARGET_DIR}/${1} $${${1}_OBJS:%.o=%.[doP]})
	$${${1}_POSTCLEAN}
endef

# ADD_OBJECT_RULE - Parameterized "function" that adds a pattern rule for
#   building object files from source files with the filename extension
#   specified in the second argument. The first argument must be the name of the
#   base directory where the object files should reside (such that the portion
#   of the path after the base directory will match the path to corresponding
#   source files). The third argument must contain the rules used to compile the
#   source files into object code form.
#
#   USE WITH EVAL
#
define ADD_OBJECT_RULE
${1}/%.o: ${2}
	${3}
endef

# ADD_TARGET_RULE - Parameterized "function" that adds a new target to the
#   Makefile. The target may be an executable or a library. The two allowable
#   types of targets are distinguished based on the name: library targets must
#   end with the traditional ".a" extension.
#
#   USE WITH EVAL
#
define ADD_TARGET_RULE
    ifeq "$$(suffix ${1})" ".a"
        # Add a target for creating a static library.
        $${TARGET_DIR}/${1}: $${${1}_OBJS}
	    @mkdir -p $$(dir $$@)
	    $$(strip $${AR} $${ARFLAGS} $$@ $${${1}_OBJS})
	    $${${1}_POSTMAKE}
    else
    ifeq "$$(suffix ${1})" ".jar"
        # Add a target for copying files.  Actually, just untars the files, kind
        # of ugly, but the only way I could discover to get the lib/ files installed.
        $${TARGET_DIR}/${1}: $${${1}}
	    @mkdir -p $$(dir $$@)
	    $$(strip tar -C $$(dir $$@) -xf $${${1}_SOURCES})
    else
        # Add a target for linking an executable. First, attempt to select the
        # appropriate front-end to use for linking. This might not choose the
        # right one (e.g. if linking with a C++ static library, but all other
        # sources are C sources), so the user makefile is allowed to specify a
        # linker to be used for each target.
        ifeq "$$(strip $${${1}_LINKER})" ""
            # No linker was explicitly specified to be used for this target. If
            # there are any C++ sources for this target, use the C++ compiler.
            # For all other targets, default to using the C compiler.
            ifneq "$$(strip $$(filter $${CXX_SRC_EXTS},$${${1}_SOURCES}))" ""
                ${1}_LINKER = $${CXX}
            else
                ${1}_LINKER = $${CC}
            endif
        endif

        $${TARGET_DIR}/${1}: $${${1}_OBJS} $${${1}_PREREQS}
	    @mkdir -p $$(dir $$@)
	    $$(strip $${${1}_LINKER} -o $$@ $${LDFLAGS} $${${1}_LDFLAGS} \
	        $${${1}_OBJS} $${${1}_LDLIBS} $${LDLIBS})
	    $${${1}_POSTMAKE}
    endif
    endif
endef

# CANONICAL_PATH - Given one or more paths, converts the paths to the canonical
#   form. The canonical form is the path, relative to the project's top-level
#   directory (the directory from which "make" is run), and without
#   any "./" or "../" sequences. For paths that are not  located below the
#   top-level directory, the canonical form is the absolute path (i.e. from
#   the root of the filesystem) also without "./" or "../" sequences.
define CANONICAL_PATH
$(patsubst ${CURDIR}/%,%,$(abspath ${1}))
endef

# COMPILE_C_CMDS - Commands for compiling C source code.
define COMPILE_C_CMDS
	@mkdir -p $(dir $@)
	$(strip ${CC} -o $@ -c -MD ${CFLAGS} ${SRC_CFLAGS} ${INCDIRS} \
	    ${SRC_INCDIRS} ${SRC_DEFS} ${DEFS} $<)
	@cp ${@:%$(suffix $@)=%.d} ${@:%$(suffix $@)=%.P}; \
	 sed -e 's/#.*//' -e 's/^[^:]*: *//' -e 's/ *\\$$//' \
	     -e '/^$$/ d' -e 's/$$/ :/' < ${@:%$(suffix $@)=%.d} \
	     >> ${@:%$(suffix $@)=%.P}; \
	 rm -f ${@:%$(suffix $@)=%.d}
endef

# COMPILE_CXX_CMDS - Commands for compiling C++ source code.
define COMPILE_CXX_CMDS
	@mkdir -p $(dir $@)
	$(strip ${CXX} -o $@ -c -MD ${CXXFLAGS} ${SRC_CXXFLAGS} ${INCDIRS} \
	    ${SRC_INCDIRS} ${SRC_DEFS} ${DEFS} $<)
	@cp ${@:%$(suffix $@)=%.d} ${@:%$(suffix $@)=%.P}; \
	 sed -e 's/#.*//' -e 's/^[^:]*: *//' -e 's/ *\\$$//' \
	     -e '/^$$/ d' -e 's/$$/ :/' < ${@:%$(suffix $@)=%.d} \
	     >> ${@:%$(suffix $@)=%.P}; \
	 rm -f ${@:%$(suffix $@)=%.d}
endef

# INCLUDE_SUBMAKEFILE - Parameterized "function" that includes a new
#   "submakefile" fragment into the overall Makefile. It also recursively
#   includes all submakefiles of the specified submakefile fragment.
#
#   USE WITH EVAL
#
define INCLUDE_SUBMAKEFILE
    # Initialize all variables that can be defined by a makefile fragment, then
    # include the specified makefile fragment.
    TARGET        :=
    TGT_CFLAGS    :=
    TGT_CXXFLAGS  :=
    TGT_DEFS      :=
    TGT_INCDIRS   :=
    TGT_LDFLAGS   :=
    TGT_LDLIBS    :=
    TGT_LINKER    :=
    TGT_POSTCLEAN :=
    TGT_POSTMAKE  :=
    TGT_PREREQS   :=

    SOURCES       :=
    SRC_CFLAGS    :=
    SRC_CXXFLAGS  :=
    SRC_DEFS      :=
    SRC_INCDIRS   :=

    SUBMAKEFILES  :=

    # A directory stack is maintained so that the correct paths are used as we
    # recursively include all submakefiles. Get the makefile's directory and
    # push it onto the stack.
    DIR := $(call CANONICAL_PATH,$(dir ${1}))
    DIR_STACK := $$(call PUSH,$${DIR_STACK},$${DIR})

    include ${1}

    # Initialize internal local variables.
    OBJS :=

    # Determine which target this makefile's variables apply to. A stack is
    # used to keep track of which target is the "current" target as we
    # recursively include other submakefiles.
    ifneq "$$(strip $${TARGET})" ""
        # This makefile defined a new target. Target variables defined by this
        # makefile apply to this new target. Initialize the target's variables.
        TGT := $$(strip $${TARGET})
        ALL_TGTS += $${TGT}
        $${TGT}_CFLAGS    := $${TGT_CFLAGS}
        $${TGT}_CXXFLAGS  := $${TGT_CXXFLAGS}
        $${TGT}_DEFS      := $${TGT_DEFS}
        $${TGT}_DEPS      :=
        TGT_INCDIRS       := $$(call QUALIFY_PATH,$${DIR},$${TGT_INCDIRS})
        TGT_INCDIRS       := $$(call CANONICAL_PATH,$${TGT_INCDIRS})
        $${TGT}_INCDIRS   := $${TGT_INCDIRS}
        $${TGT}_LDFLAGS   := $${TGT_LDFLAGS}
        $${TGT}_LDLIBS    := $${TGT_LDLIBS}
        $${TGT}_LINKER    := $${TGT_LINKER}
        $${TGT}_OBJS      :=
        $${TGT}_POSTCLEAN := $${TGT_POSTCLEAN}
        $${TGT}_POSTMAKE  := $${TGT_POSTMAKE}
        $${TGT}_PREREQS   := $$(addprefix $${TARGET_DIR}/,$${TGT_PREREQS})
        $${TGT}_SOURCES   :=
    else
        # The values defined by this makefile apply to the the "current" target
        # as determined by which target is at the top of the stack.
        TGT := $$(strip $$(call PEEK,$${TGT_STACK}))
        $${TGT}_CFLAGS    += $${TGT_CFLAGS}
        $${TGT}_CXXFLAGS  += $${TGT_CXXFLAGS}
        $${TGT}_DEFS      += $${TGT_DEFS}
        TGT_INCDIRS       := $$(call QUALIFY_PATH,$${DIR},$${TGT_INCDIRS})
        TGT_INCDIRS       := $$(call CANONICAL_PATH,$${TGT_INCDIRS})
        $${TGT}_INCDIRS   += $${TGT_INCDIRS}
        $${TGT}_LDFLAGS   += $${TGT_LDFLAGS}
        $${TGT}_LDLIBS    += $${TGT_LDLIBS}
        $${TGT}_POSTCLEAN += $${TGT_POSTCLEAN}
        $${TGT}_POSTMAKE  += $${TGT_POSTMAKE}
        $${TGT}_PREREQS   += $${TGT_PREREQS}
    endif

    # Push the current target onto the target stack.
    TGT_STACK := $$(call PUSH,$${TGT_STACK},$${TGT})

    ifneq "$$(strip $${SOURCES})" ""
        # This makefile builds one or more objects from source. Validate the
        # specified sources against the supported source file types.
        BAD_SRCS := $$(strip $$(filter-out $${ALL_SRC_EXTS},$${SOURCES}))
        ifneq "$${BAD_SRCS}" ""
            $$(error Unsupported source file(s) found in ${1} [$${BAD_SRCS}])
        endif

        # Qualify and canonicalize paths.
        SOURCES     := $$(call QUALIFY_PATH,$${DIR},$${SOURCES})
        SOURCES     := $$(call CANONICAL_PATH,$${SOURCES})
        SRC_INCDIRS := $$(call QUALIFY_PATH,$${DIR},$${SRC_INCDIRS})
        SRC_INCDIRS := $$(call CANONICAL_PATH,$${SRC_INCDIRS})

        # Save the list of source files for this target.
        $${TGT}_SOURCES += $${SOURCES}

        # Convert the source file names to their corresponding object file
        # names.
        OBJS := $$(addprefix $${BUILD_DIR}/$$(call CANONICAL_PATH,$${TGT})/,\
                   $$(addsuffix .o,$$(basename $${SOURCES})))

        # Add the objects to the current target's list of objects, and create
        # target-specific variables for the objects based on any source
        # variables that were defined.
        $${TGT}_OBJS += $${OBJS}
        $${TGT}_DEPS += $${OBJS:%.o=%.P}
        $${OBJS}: SRC_CFLAGS   := $${$${TGT}_CFLAGS} $${SRC_CFLAGS}
        $${OBJS}: SRC_CXXFLAGS := $${$${TGT}_CXXFLAGS} $${SRC_CXXFLAGS}
        $${OBJS}: SRC_DEFS     := $$(addprefix -D,$${$${TGT}_DEFS} $${SRC_DEFS})
        $${OBJS}: SRC_INCDIRS  := $$(addprefix -I,\
                                     $${$${TGT}_INCDIRS} $${SRC_INCDIRS})
    endif

    ifneq "$$(strip $${SUBMAKEFILES})" ""
        # This makefile has submakefiles. Recursively include them.
        $$(foreach MK,$${SUBMAKEFILES},\
           $$(eval $$(call INCLUDE_SUBMAKEFILE,\
                      $$(call CANONICAL_PATH,\
                         $$(call QUALIFY_PATH,$${DIR},$${MK})))))
    endif

    # Reset the "current" target to it's previous value.
    TGT_STACK := $$(call POP,$${TGT_STACK})
    TGT := $$(call PEEK,$${TGT_STACK})

    # Reset the "current" directory to it's previous value.
    DIR_STACK := $$(call POP,$${DIR_STACK})
    DIR := $$(call PEEK,$${DIR_STACK})
endef


# MIN - Parameterized "function" that results in the minimum lexical value of
#   the two values given.
define MIN
$(firstword $(sort ${1} ${2}))
endef

# PEEK - Parameterized "function" that results in the value at the top of the
#   specified colon-delimited stack.
define PEEK
$(lastword $(subst :, ,${1}))
endef

# POP - Parameterized "function" that pops the top value off of the specified
#   colon-delimited stack, and results in the new value of the stack. Note that
#   the popped value cannot be obtained using this function; use peek for that.
define POP
${1:%:$(lastword $(subst :, ,${1}))=%}
endef

# PUSH - Parameterized "function" that pushes a value onto the specified colon-
#   delimited stack, and results in the new value of the stack.
define PUSH
${2:%=${1}:%}
endef

=== debian/changelog ===
canu (1.5+dfsg-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: Drop Files-Excluded entries for files removed upstream
  * Refresh and update patches

 -- Afif Elghraoui <afif@debian.org>  Thu, 18 May 2017 01:59:14 -0400

=== debian/control ===
Source: canu
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@debian.org>
Build-Depends:
	debhelper (>= 9),
	libboost-dev,
	libmeryl-dev,
# For File::Path
	libfilesys-df-perl,
Standards-Version: 3.9.8
Homepage: http://canu.readthedocs.org/en/latest/
Vcs-Git: https://anonscm.debian.org/git/debian-med/canu.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/canu.git

Package: canu
Architecture: any
Depends:
	${shlibs:Depends},
	${misc:Depends},
	${perl:Depends},
	libfilesys-df-perl,
	mhap (>= 2.1),
Recommends: gnuplot
Suggests:
	pbgenomicconsensus,
	nanopolish,
Description: single molecule sequence assembler for genomes
 Canu is a fork of the Celera Assembler, designed for high-noise
 single-molecule sequencing (such as the PacBio RS II or Oxford
 Nanopore MinION).
 .
 Canu is a hierarchical assembly pipeline which runs in four steps:
 .
  * Detect overlaps in high-noise sequences using MHAP
  * Generate corrected sequence consensus
  * Trim corrected sequences
  * Assemble trimmed corrected sequences

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1
include /usr/share/dpkg/default.mk

#export CPPFLAGS += -I/usr/include/kmer
export CFLAGS := $(CPPFLAGS) $(CFLAGS)
export CXXFLAGS := $(CPPFLAGS) $(CXXFLAGS)

%:
	dh $@ --parallel --sourcedirectory=src/

override_dh_auto_build:
	dh_auto_build
	builddir=*-*/; \
	mkdir -p lib/canu share/perl5 && mv lib share $$builddir; \
	mv $$builddir/bin/lib/canu $$builddir/share/perl5; \
	mv $$builddir/bin/* $$builddir/lib/canu; \
	find $$builddir \
	-name OverlapMhap.pm \
	-exec sed -i 's#\(\s*my \$$javaPath = \).*#\1 "/usr/lib/jvm/java-8-openjdk-$(DEB_HOST_ARCH)/bin/java";#' {} +

## canu 1.6+dfsg

=== src/meryl/libleaff/test/Makefile ===


PROG    = test-merstream-speed

INCLUDE = -I.. -I../../libutil -I../../libbio -I../../libseq
LIBS    = -L.. -L../../libutil -L../../libbio -L../../libseq -lseq -lbio -lutil -lm
OBJS    = 

include ../../Make.compilers

all: $(PROG)
	@echo Tests passed!

test-merstream-speed: test-merstream-speed.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-merstream-speed.o test-merstream-speed.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-merstream-speed test-merstream-speed.o $(LIBS)
	../../leaff/leaff -G 10000 1000 10000 > junk.fasta
	cat junk.fasta > /dev/null
	./test-merstream-speed junk.fasta
	rm -f junk*

clean:
	rm -f $(PROG) *.o *junk*

=== debian/changelog ===
canu (1.6+dfsg-2) unstable; urgency=medium

  * Team upload

  [ Steffen Moeller ]
  * debian/upstream/metadata
    - yamllint cleanliness
    - added references to registries

  [ Andreas Tille ]
  * Add mhap to Build-Depends (thanks for the patch to Steve Langasek
    <steve.langasek@canonical.com>)
    Closes: #883047
  * Standards-Version: 4.1.1

 -- Andreas Tille <tille@debian.org>  Fri, 01 Dec 2017 09:01:30 +0100

canu (1.6+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version
  * debhelper 10
  * Standards-Version: 4.1.0 (no changes needed)
  * Fix gcc-7 error (violation of format-security)
    Closes: #871390
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Sat, 02 Sep 2017 15:59:58 +0200

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,13 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Afif Elghraoui <afif@debian.org>
 Build-Depends:
-	debhelper (>= 9),
+	debhelper (>= 10),
 	libboost-dev,
 	libmeryl-dev,
 # For File::Path
 	libfilesys-df-perl,
-Standards-Version: 3.9.8
+	mhap (>= 2.1)
+Standards-Version: 4.1.1
 Homepage: http://canu.readthedocs.org/en/latest/
 Vcs-Git: https://anonscm.debian.org/git/debian-med/canu.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/canu.git

=== debian/rules ===
--- 
+++ 
@@ -7,8 +7,10 @@
 export CFLAGS := $(CPPFLAGS) $(CFLAGS)
 export CXXFLAGS := $(CPPFLAGS) $(CXXFLAGS)
 
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
 %:
-	dh $@ --parallel --sourcedirectory=src/
+	dh $@ --sourcedirectory=src/
 
 override_dh_auto_build:
 	dh_auto_build

## canu 1.7+dfsg

=== debian/changelog ===
canu (1.7+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Update handling of mhap bundled copy
  * Refresh patches
  * Use a wrapper script for main program
  * move gnuplot to Depends from Recommends
  * Bump mhap minimum version
  * Bump Standards-Version to 4.1.3

 -- Afif Elghraoui <afif@debian.org>  Sat, 17 Mar 2018 18:09:13 -0400

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,8 @@
 	libmeryl-dev,
 # For File::Path
 	libfilesys-df-perl,
-	mhap (>= 2.1)
-Standards-Version: 4.1.1
+	mhap (>= 2.1.3)
+Standards-Version: 4.1.3
 Homepage: http://canu.readthedocs.org/en/latest/
 Vcs-Git: https://anonscm.debian.org/git/debian-med/canu.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/canu.git
@@ -22,8 +22,8 @@
 	${misc:Depends},
 	${perl:Depends},
 	libfilesys-df-perl,
-	mhap (>= 2.1),
-Recommends: gnuplot
+	mhap (>= 2.1.3),
+	gnuplot,
 Suggests:
 	pbgenomicconsensus,
 	nanopolish,

## canu 1.7.1+dfsg

=== src/Makefile ===
--- 
+++ 
@@ -67,40 +67,31 @@
     ifeq "$$(suffix ${1})" ".a"
         # Add a target for creating a static library.
         $${TARGET_DIR}/${1}: $${${1}_OBJS}
-	    @mkdir -p $$(dir $$@)
-	    $$(strip $${AR} $${ARFLAGS} $$@ $${${1}_OBJS})
-	    $${${1}_POSTMAKE}
+	        @mkdir -p $$(dir $$@)
+	        $$(strip $${AR} $${ARFLAGS} $$@ $${${1}_OBJS})
+	        $${${1}_POSTMAKE}
     else
-    ifeq "$$(suffix ${1})" ".jar"
-        # Add a target for copying files.  Actually, just untars the files, kind
-        # of ugly, but the only way I could discover to get the lib/ files installed.
-        $${TARGET_DIR}/${1}: $${${1}}
-	    @mkdir -p $$(dir $$@)
-	    $$(strip tar -C $$(dir $$@) -xf $${${1}_SOURCES})
-    else
-        # Add a target for linking an executable. First, attempt to select the
-        # appropriate front-end to use for linking. This might not choose the
-        # right one (e.g. if linking with a C++ static library, but all other
-        # sources are C sources), so the user makefile is allowed to specify a
-        # linker to be used for each target.
-        ifeq "$$(strip $${${1}_LINKER})" ""
-            # No linker was explicitly specified to be used for this target. If
-            # there are any C++ sources for this target, use the C++ compiler.
-            # For all other targets, default to using the C compiler.
-            ifneq "$$(strip $$(filter $${CXX_SRC_EXTS},$${${1}_SOURCES}))" ""
-                ${1}_LINKER = $${CXX}
-            else
-                ${1}_LINKER = $${CC}
-            endif
-        endif
-
-        $${TARGET_DIR}/${1}: $${${1}_OBJS} $${${1}_PREREQS}
-	    @mkdir -p $$(dir $$@)
-	    $$(strip $${${1}_LINKER} -o $$@ $${LDFLAGS} $${${1}_LDFLAGS} \
-	        $${${1}_OBJS} $${${1}_LDLIBS} $${LDLIBS})
-	    $${${1}_POSTMAKE}
-    endif
-    endif
+      # Add a target for linking an executable. First, attempt to select the
+      # appropriate front-end to use for linking. This might not choose the
+      # right one (e.g. if linking with a C++ static library, but all other
+      # sources are C sources), so the user makefile is allowed to specify a
+      # linker to be used for each target.
+      ifeq "$$(strip $${${1}_LINKER})" ""
+          # No linker was explicitly specified to be used for this target. If
+          # there are any C++ sources for this target, use the C++ compiler.
+          # For all other targets, default to using the C compiler.
+          ifneq "$$(strip $$(filter $${CXX_SRC_EXTS},$${${1}_SOURCES}))" ""
+              ${1}_LINKER = $${CXX}
+          else
+              ${1}_LINKER = $${CC}
+          endif
+      endif
+
+      $${TARGET_DIR}/${1}: $${${1}_OBJS} $${${1}_PREREQS}
+	      @mkdir -p $$(dir $$@)
+	      $$(strip $${${1}_LINKER} -o $$@ $${LDFLAGS} $${${1}_LDFLAGS} $${${1}_OBJS} $${${1}_LDLIBS} $${LDLIBS})
+	      $${${1}_POSTMAKE}
+  endif
 endef
 
 # CANONICAL_PATH - Given one or more paths, converts the paths to the canonical
@@ -183,7 +174,12 @@
     ifneq "$$(strip $${TARGET})" ""
         # This makefile defined a new target. Target variables defined by this
         # makefile apply to this new target. Initialize the target's variables.
-        TGT := $$(strip $${TARGET})
+
+        ifeq "$$(suffix $${TARGET})" ".a"
+          TGT := $$(addprefix lib/, $$(strip $${TARGET}))
+        else
+          TGT := $$(addprefix bin/, $$(strip $${TARGET}))
+        endif
         ALL_TGTS += $${TGT}
         $${TGT}_CFLAGS    := $${TGT_CFLAGS}
         $${TGT}_CXXFLAGS  := $${TGT_CXXFLAGS}
@@ -198,7 +194,7 @@
         $${TGT}_OBJS      :=
         $${TGT}_POSTCLEAN := $${TGT_POSTCLEAN}
         $${TGT}_POSTMAKE  := $${TGT_POSTMAKE}
-        $${TGT}_PREREQS   := $$(addprefix $${TARGET_DIR}/,$${TGT_PREREQS})
+        $${TGT}_PREREQS   := $$(addprefix $${TARGET_DIR}/lib/,$${TGT_PREREQS})
         $${TGT}_SOURCES   :=
     else
         # The values defined by this makefile apply to the the "current" target
@@ -297,3 +293,6 @@
 ${2:%=${1}:%}
 endef
 
+# QUALIFY_PATH - Given a "root" directory and one or more paths, qualifies the
+#   paths using the "root" directory (i.e. appends the root directory name to
+#   the paths) except for paths that are absolute.

=== debian/changelog ===
canu (1.7.1+dfsg-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Andreas Tille <tille@debian.org>  Wed, 17 Oct 2018 13:30:08 +0200

canu (1.7.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5

 -- Andreas Tille <tille@debian.org>  Tue, 17 Jul 2018 12:34:50 +0200

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,6 @@
 override_dh_auto_build:
 	dh_auto_build
 	builddir=*-*/; \
-	mkdir -p lib/canu share/perl5 && mv lib share $$builddir; \
-	mv $$builddir/bin/lib/canu $$builddir/share/perl5; \
-	mv $$builddir/bin/* $$builddir/lib/canu; \
 	find $$builddir \
 	-name OverlapMhap.pm \
 	-exec sed -i 's#\(\s*my \$$javaPath = \).*#\1 "/usr/lib/jvm/java-8-openjdk-$(DEB_HOST_ARCH)/bin/java";#' {} +

## canu 1.8+dfsg

=== debian/changelog ===
canu (1.8+dfsg-2) unstable; urgency=medium

  * Team upload
  * Properly reporting version number

 -- Andreas Tille <tille@debian.org>  Mon, 03 Dec 2018 09:55:59 +0100

canu (1.8+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.2.1
  * Remove unused paragraphs in d/copyright
  * Fix perl interpreter path

 -- Andreas Tille <tille@debian.org>  Thu, 01 Nov 2018 08:56:31 +0100

=== debian/control ===
Source: canu
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               libboost-dev,
               libmeryl-dev,
# For File::Path
               libfilesys-df-perl,
               mhap (>= 2.1.3)
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/canu
Vcs-Git: https://salsa.debian.org/med-team/canu.git
Homepage: http://canu.readthedocs.org/en/latest/

Package: canu
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         libfilesys-df-perl,
         mhap (>= 2.1.3),
         gnuplot
Suggests: pbgenomicconsensus,
          nanopolish
Description: single molecule sequence assembler for genomes
 Canu is a fork of the Celera Assembler, designed for high-noise
 single-molecule sequencing (such as the PacBio RS II or Oxford
 Nanopore MinION).
 .
 Canu is a hierarchical assembly pipeline which runs in four steps:
 .
  * Detect overlaps in high-noise sequences using MHAP
  * Generate corrected sequence consensus
  * Trim corrected sequences
  * Assemble trimmed corrected sequences

=== debian/rules ===
--- 
+++ 
@@ -18,3 +18,9 @@
 	find $$builddir \
 	-name OverlapMhap.pm \
 	-exec sed -i 's#\(\s*my \$$javaPath = \).*#\1 "/usr/lib/jvm/java-8-openjdk-$(DEB_HOST_ARCH)/bin/java";#' {} +
+
+override_dh_install:
+	dh_install
+	for pl in `grep -Rl '#![[:space:]]*/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
+	    sed -i '1s?^#![[:space:]]*/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
+	done

## canu 1.9+dfsg

=== debian/changelog ===
canu (1.9+dfsg-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:35:35 +0100

canu (1.9+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper-compat 12

 -- Steffen Moeller <moeller@debian.org>  Sun, 10 Nov 2019 11:12:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: canu
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Afif Elghraoui <afif@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                libboost-dev,
                libmeryl-dev,
 # For File::Path
                libfilesys-df-perl,
                mhap (>= 2.1.3)
-Standards-Version: 4.2.1
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/med-team/canu
 Vcs-Git: https://salsa.debian.org/med-team/canu.git
 Homepage: http://canu.readthedocs.org/en/latest/

=== debian/rules ===
--- 
+++ 
@@ -24,3 +24,7 @@
 	for pl in `grep -Rl '#![[:space:]]*/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
 	    sed -i '1s?^#![[:space:]]*/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
 	done
+
+override_dh_auto_clean:
+	rm -rf Linux-*
+	rm -f src/canu_version.H

## canu 2.0+dfsg

=== debian/changelog ===
canu (2.0+dfsg-2) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix FTBFS with new glibc (Closes: #997215)
  * Run cme

 -- Nilesh Patra <nilesh@debian.org>  Fri, 29 Oct 2021 01:57:43 +0530

canu (2.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * Removed patch tell_version_properly.patch since already in upstream

 -- Steffen Moeller <moeller@debian.org>  Sat, 28 Mar 2020 00:42:06 +0100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libboost-dev,
                libmeryl-dev,
 # For File::Path
                libfilesys-df-perl,
-               mhap (>= 2.1.3)
-Standards-Version: 4.4.1
+               mhap
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/canu
 Vcs-Git: https://salsa.debian.org/med-team/canu.git
 Homepage: http://canu.readthedocs.org/en/latest/
@@ -19,7 +19,7 @@
          ${misc:Depends},
          ${perl:Depends},
          libfilesys-df-perl,
-         mhap (>= 2.1.3),
+         mhap,
          gnuplot
 Suggests: pbgenomicconsensus,
           nanopolish

=== debian/watch ===
version=4

opts=\
     filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%canu-$1.tar.gz%,\
     repacksuffix=+dfsg,\
     dversionmangle=s/\+dfsg\d*$// \
	https://github.com/marbl/canu/tags \
	(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
